E_pred<-readRDS("E_pred_sim_o=1000_ns=120.RDS")
E_sim<-readRDS("E_sim_o=1000.RDS")

is_exact<-function(e_pred, e){
  exact_period<-e_pred[[1]][1] == e[[1]][1] & e_pred[[1]][2] == e[[1]][[2]]
  #exact_period<-e_pred[[1]][1] >= e[[1]][1] -10 & e_pred[[1]][2] <= e[[1]][[2]] +10
  exact_dim<-length(e_pred[[2]]) == length(e[[2]]) & all(e_pred[[2]] %in% e[[2]])
  return(exact_period & exact_dim)
}

fit_with_tol<-function(e_pred, e, tol1, tol2){
  sub_period<-(e_pred[[1]][1] >= e[[1]][1]-tol1 & e_pred[[1]][2] <= e[[1]][[2]]+tol1) & (e[[1]][1] >= e_pred[[1]][1]-tol1 & e[[1]][2] <= e_pred[[1]][[2]]+tol1)
  sub_dim<-sum(! e_pred[[2]] %in% e[[2]]) <= tol2 & sum(! e[[2]] %in% e_pred[[2]]) <= tol2
  return(sub_period &sub_dim)
}

eval_tol_recall<-function(tol1, tol2){
  count_tol<-0
  for(j in 1:length(E_sim)){
    for(i in 1:length(E_pred)){
      if(fit_with_tol(E_pred[[i]], E_sim[[j]], tol1, tol2)){
        count_tol<-count_tol+1
        break
      }
    }
  }
  return(count_tol/length(E_sim))
}

eval_tol_prec<-function(tol1, tol2){
  count_tol<-0
  for(i in 1:length(E_pred)){
    for(j in 1:length(E_sim)){
      if(fit_with_tol(E_pred[[i]], E_sim[[j]], tol1, tol2)){
        count_tol<-count_tol+1
        break
      }
    }
  }
  return(count_tol/length(E_pred))
}

print(c(eval_tol_recall(3,2),eval_tol_recall(3,3),eval_tol_recall(5,2),eval_tol_recall(5,3),eval_tol_recall(8,2),eval_tol_recall(8,3),eval_tol_prec(3,2),eval_tol_prec(3,3),eval_tol_prec(5,2),eval_tol_prec(5,3),eval_tol_prec(8,2),eval_tol_prec(8,3)))

#print(sub_pair)
