library(forecast)
library(randtests)
d<-as.matrix(read.csv("simulated_o=1000.csv"))

k_max<-12
k_min<-3
n<-dim(d)[1]
m<-dim(d)[2]
c_min<-3
delta<-0.02

fn<-function(TS){
  return(as.numeric(bartels.rank.test(TS)[3]))
}

find_intervals<-function(TS, k_min, k_max, fn, delta){
  Is<-{}
  i<-1
  while(i < length(TS) - k_min){
    li<-{}
    for(j in (i+k_min):(min(length(TS), i+k_max))){
      if(fn(TS[-(i:j)]) - fn(TS) > delta){
        li<-c(i, j)
      }
    }
    if(length(li) == 0){
      i<-i+1
    }else{
      Is<-rbind(Is, li)
      i<-li[2]+1
    }
  }
  return(Is)
}



get_d<-function(e){
  return(e[[2]])
}
get_length<-function(e){
  start<-e[[1]][1]
  end<-e[[1]][2]
  return(end-start+1)
}
get_start<-function(e){
  return(e[[1]][1])
}

# run from here
TSs_REF<-d[1:100,]

E<-list()
E_half<-list()
k_block<-20
for(i in 120:(n-k_min)){
#  print(c("i",i))
  TSs_CUR<-d[(i-k_block+1):i,]
  D_cur<-{}
  for(j in 1:m){
    if(fn(TSs_REF[,j]) - fn(c(TSs_REF[,j], TSs_CUR[,j])) > delta){
      D_cur<-c(D_cur, j)
    }
  }
  D_old<-numeric(0)
  to_remove<-numeric(0)
  if(length(E_half) > 0){
    for(e_index in 1:length(E_half)){
      e_half<-E_half[[e_index]]
      D_continuing<-intersect(get_d(e_half), D_cur)
      if(length(D_continuing) == 0) next
      to_remove<-c(to_remove, e_index)
      if(length(D_continuing) >= c_min){
        e_continuing<-list(c(get_start(e_half), i), D_continuing)
        E_half[[length(E_half)+1]]<-e_continuing
        D_old<-union(D_old, D_continuing)
      }else{
        D_continuing<-numeric(0)
      }
      e_finished<-list(c(get_start(e_half), i), get_d(e_half)[! get_d(e_half) %in% D_continuing])
      if(get_length(e_finished) >= k_min & length(get_d(e_finished)) >= c_min){
        E[[length(E)+1]]<-e_finished
        D_old<-union(D_old, intersect(get_d(e_finished), D_cur))
      }
    }
  }
  #print(E_half)
  if(length(to_remove) > 0) E_half<-E_half[-to_remove]
  D_new<-D_cur[! D_cur %in% D_old]
  if(length(D_new) >= c_min){
    E_half[[length(E_half)+1]]<-list(c(i, i), D_new)
  }
}
print(length(E))
saveRDS(E, file = "E_pred_inc_sim_o=1000_ns=120.RDS")
